% This .m file converts a given image file into a colour .eps file.

fig_no = 211;
output_format='epsc'; %select colour .eps as output format

% Pick file
[file_name,path_name,filter_spec] = uigetfile('*.*');

output_name = file_name(1:end-4);
input_format = file_name(end-2:end);

% Load file as image
[A,map]=imread([path_name,file_name],input_format);

% Display image
figure(fig_no);
clf;
image(A);
colormap(map);
axis equal off;

% Save in new format
saveas(fig_no,[path_name,output_name],output_format);
close(fig_no);