%% 2. Robot arm
macfg = struct; 
macfg.nagents = 3; 
macfg.G = [0 1 1; 1 0 0; 1 0 0];        % undirected graph 2 -- 1 -- 3
macfg.maxomega = [15*pi;  15*pi];       % [rad/sec] maximum angular speeds of links
macfg.maxtau =   [50;    50];           % [Nm] maximum torques
macfg.orientation = 'horizontal';
macfg.Ts = 0.05;

cfg = struct;
cfg.problem = 'mararm_problem';
cfg.model_params = {macfg}; 
cfg.optparams.method = 'soo';
% cfg.optparams.diam = @(urange) 3*norm((urange(2, :) - urange(1, :))./2, 2);  % for DOO, assuming locally linear
cfg.optparams.dmax = @(t) sqrt(t); % for SOO
cfg.optparams.n = 300;
cfg.optparams.verb = 5;
cfg.trials = 1;
cfg.maxsteps = 100;
cfg.K = 2;
cfg.alpha = 0.45;
cfg.optparams.maxu = repmat(macfg.maxtau, cfg.K, 1); % repeat bounds
% regular initial states
cfg.reset = [-pi, 0, -pi/2, 0; 0, 0, 0, 0; pi/2, 0, pi, 0]';
cfg.datafile = sprintf('oocons_mararm_alpha%s_soo_n%d', num2strx(cfg.alpha, 'r'), cfg.optparams.n);
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.run = 1;
ooconsensus(cfg);
