function df = ceconfig2filename(cfg, n, nlabel, iter)
% OBSOLETE, used in the obsolete functions ceexp_run and ceexp_eval
% Use optimexp instead, which includes its own file generation function
% Makes a conventional file name out of config, N of basis functions, and iter# for use with CE
% experiments

% fixed part
df = '';
switch cfg.problem,
    case 'hillcar_problem',         df = [df 'hc'];
    case 'ddi_problem',             df = [df 'dd'];
    case 'bike_problem',            df = [df 'bike'];
end;
switch cfg.alg,
    case 'cerbfps',
        df = [df '_ps'];
    case 'cerbfqi',
        df = [df '_ceqi'];
    case 'cefuzzyqi',
        df = [df '_cefzqi'];
end;
if ~isempty(cfg.infix),
    df = [df '_' cfg.infix];
end;
if ischar(cfg.X0),
    df = [df '_' cfg.X0];
else 
    df = [df '_otherX0'];
end;

% N and iter-varying part
df = [df '_' nlabel num2str(n)];
if iter > 0,
    df = [df '_#' num2str(iter-1+cfg.startat)];
end;

% again fixed postfix
df = [df cfg.postfix];