function ceexp_run(cfg)
% For CE fuzzy QI, currently only supports same number of centers on each axis
% This function is OBSOLETE when used with cerbfps experiments; use OPTIMEXP instead

if nargin < 1, cfg = struct; end;
% defaults
CFG.problem = 'hillcar_problem';
CFG.alg = 'cerbfps';
CFG.resume = 0;
CFG.ce_alpha = 1;
CFG.ce_beta = -1;
CFG.ce_gamma = -1;
% options for policy search
CFG.actsel = 'max';
CFG.mc_noise = 'online';
% options for qiter
CFG.cost = 'mc';
CFG.type = 'crad';      % constrained radii
% common options
CFG.model_params = {};
CFG.X0 = 'zero';
CFG.N = 3:10;
CFG.Np = 3:10;
CFG.startat = 1;
CFG.verb = 2;       % don't display count of samples by default
CFG.iter = 1;
CFG.infix = '';
CFG.postfix = '';

cfg = checkparams(str2cfg(cfg, CFG), CFG); 


% pre-establish algorithm function to call
if strcmp(cfg.alg, 'cerbfps'),  % use compatibility version of cerbfps
    algfun = 'cerbfps_old';
else                            % use the algorithm name
    algfun = cfg.alg;
end;


switch cfg.alg,
    case {'cerbfps','cerbfqi'}
        range = cfg.N;
        nlabel = 'N';
    case 'cefuzzyqi',
        range = cfg.Np;
        nlabel = 'Np';
end;

for n = range,
    % form CE config
    ce = struct;
    if cfg.resume,
        ce.resume = 1;
    else
        ce.run = 1;
    end;
    ce.problem = cfg.problem;
    ce.model_params = cfg.model_params;
    % smoothing params
    ce.ce_alpha = cfg.ce_alpha;
    ce.ce_beta = cfg.ce_beta;
    switch cfg.alg,
        case 'cerbfps',
            ce.ce_gamma = cfg.ce_gamma;     % Bernoulli smoothing
            ce.N = n;
            ce.actsel = cfg.actsel;
            ce.mc_noise = cfg.mc_noise;
        case 'cerbfqi',
            ce.N = n;
            ce.type = cfg.type;
            ce.cost = cfg.cost;
        case 'cefuzzyqi',     
            ce.Np = n;
            ce.cost = cfg.cost;
    end;
    ce.verb = cfg.verb;
    ce.ce_params = {cfg.X0};
    for i = 1:cfg.iter,
        ce.datafile = ceconfig2filename(cfg, n, nlabel, i);
        try
            % call the algorithm
            feval(algfun, ce);
        catch
            [msgstr, msgid] = lasterr;
            disp('Experiment not completed, an error was detected:');
            disp([msgid ': ' msgstr ]);
        end;
    end;
    
end;

