classdef opssnode < handle
    properties(SetAccess=public)
      parent    % parent node (handle)
      parentj   % the action that was applied at parent to get this node
      children  % children node (Mx1 cell array of handle vectors, one for each action)
      depth
      leaf      % boolean flag whether node is leaf
      x         % state of this node
      f         % one-step probability of reaching this node
      r         % reward on transition to this node
      term      % whether transition to this node is terminal
      b         % b-values of all actions in this node
      util      % u-values of all actions in this node
      P         % overall probability of (path to) this node 
      R         % overall return up to this node
    end
   
methods

function node = opssnode
    % construct an empty node
end
    
% possibly useful variant, which takes an arbitrary set of properties as a structure
% function node = opssnode(props)
%     if isempty(props), return; end;
%     propnames = fieldnames(props);
%     for i = 1 : length(propnames),
%         node.(propnames{i}) = props.(propnames{i});
%     end;
% end

end     % methods

end     % class